#include <stdlib.h>
#include <string.h>

#include "cad4io.h"

/* swaps the values in an array[2] of shorts */

void swap_short2( unsigned short *sa )
{
    unsigned short tmp;
    
    tmp = sa[0];
    sa[0] = sa[1];
    sa[1] = tmp;

    return;
}


float conv_shorts_to_float( unsigned short *sa )
{
    float ret_val;

    memcpy( &ret_val, sa, sizeof(float) );
    return ret_val;
}

void conv_float_to_shorts( float *f, unsigned short *sa )
{
    memcpy( sa, f, sizeof(float) );
}

float motor_to_angle( int encoder )
{
    float angle;

    angle = DGRST * (float) encoder;

    if( angle > 180.0)  angle -= 360.0;

    return angle;
}

int angle_to_motor( float angle )
{
    int encoder;

    if( angle > 180.0 ) angle -= 360.0;
    
    return (int)angle * STDGR;
}

/* takes a CAD4_Buffer data and fills a cad4_main struct.  Used after
 * reading a data from a port.
 */
void cad4_recv_gonio( struct cad4_main *cd4_m, CAD4_Buffer *recvd )
{
    cd4_m->nswreg = recvd->addr0;
    cd4_m->xrayt = conv_shorts_to_float( &(recvd->data.s[C4H_XRTIM]) );
    cd4_m->cmeas[FOR_TH] = conv_shorts_to_float( &(recvd->data.s[C4H_THMH]) );
    cd4_m->cmeas[FOR_PH] = conv_shorts_to_float( &(recvd->data.s[C4H_PHMH]) );
    cd4_m->cmeas[FOR_OM] = conv_shorts_to_float( &(recvd->data.s[C4H_OHMH]) );
    cd4_m->cmeas[FOR_KA] = conv_shorts_to_float( &(recvd->data.s[C4H_KAMH]) );
    cd4_m->aptm = conv_shorts_to_float( &(recvd->data.s[C4H_APMH]) );

    return;
}


/* takes a cad4_main struct and loads a CAD4_Buffer to be written to the
 * the interface 
 */
void cad4_transm_gonio( )
{

    return;
}
