#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "cad4io.h"

#define INPUT_LEN  24

void InputDialog( unsigned char *input);

int main( void )
{
    unsigned char ret_val, 
                  input;

    unsigned short new_start = 0xff & (FN_REQ_MEM + E_TYP);
    fprintf( stdout, "LSI new start code: %#hx\n", new_start );

    InputDialog( &input );

    ret_val = input & M_EFL;

    if( E_SUC == ret_val ) {
        unsigned short m_seq_number = 0,
              m_fun = 0;
        m_seq_number = input & M_SEQ;
        m_fun = input & M_FUN;
        fprintf( stdout, "Success: input & M_EFL = %#hx\n", ret_val );     

        fprintf( stdout, "Sequence number = %hd (%#hx)\n", m_seq_number, 
                          m_seq_number ); 
        fprintf( stdout, "Function define: %hd (%#hx)\n", m_fun, m_fun );
        fprintf( stdout, "Function code: %hd (%#hx)\n",
                          m_fun/0x20, m_fun/0x20 );

    }
    else {
        unsigned short res = 0;
        res = input & (M_EFL + M_FUN);
        fprintf( stdout, "Failure: input & M_EFL = %#hx\n", ret_val );     
        if( res == new_start )
            fprintf( stdout, "LSI wants a new start: %hd (%#hx)\n", res, res );
        else
            fprintf( stdout, "input & (M_EFL + M_FUN) = %hd (%#hx)\n",
                               res, res );
        
    }

    fputs( "\n\n", stdout );

    exit( EXIT_SUCCESS );

}


void InputDialog( unsigned char *input )
{

    char line[INPUT_LEN],
         *ptr;
    unsigned short  val;

     fputs( "Enter hexnumber: ", stdout );
     fflush( stdout );

     if( NULL == fgets(line, sizeof(line), stdin) ) {
         fputs( "fgets() returned NULL. Exiting.\n", stderr );
         exit( EXIT_FAILURE );
     }

     if( NULL != (ptr = strchr(line, '\n')) ) *ptr = '\0';

     sscanf( line, "%hx", &val );

     *input = (unsigned char)val;
     return;
}
