#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>


#define STDGR ( 128.0 * 4096.0 / 360.0 ) /* the "magic" constant */
#define LINE_LEN 80


float d2f( short int high, short int low )
{
    long tmp = 0;
  
/* this is how to convert a 2 complement number (supposedly).  I don't
 * know really what I am doing here.  If low order word is negative,
 * then convert it to it's absolute value.  PDP-11 supposedly use 2
 * complements for representing signed integers.
 */
    if( low < 0 ) 
        low = ~low + 1;

    tmp |= (long)high << (CHAR_BIT * sizeof(short));
    tmp |= (unsigned)low;

    return (float)tmp / STDGR;
}

int main( void )
{
    char line[LINE_LEN],
         *ptr;

    unsigned short  hi, lo;
    float fconv;
    int n_items = 0;

/* prompt for the input */
    do { 
        n_items = 0;
        memset( line, '\0', sizeof(line) );
        fputs( "Enter high and low values: ", stdout );
        fflush( stdout );
        if( NULL == fgets(line, sizeof(line), stdin) ) {
            fputs( "fgets() has a problem.\n", stderr );
            exit( EXIT_FAILURE );
        }
        if( NULL != (ptr = strchr(line, '\n')) ) *ptr = '\0';
        n_items = sscanf( line, "%hx %hx", &hi, &lo );
        if( n_items != 2 )
            fputs( "Opps! wrong input, try again!\n", stderr );
    } while( n_items != 2 );

    fconv = d2f( hi, lo );
    printf( "High: %#hx, Low: %#hx, Float: %8.3f\n", hi, lo, fconv );

    exit( EXIT_SUCCESS );
}
